#include "fenetre.h"



//----------------------------------------------------------------------------------
// cre et initialise une boite
//----------------------------------------------------------------------------------
void creerBoite(BOITE *boite,int x, int y, int largeur, int hauteur, int borderwidth, int bordercolor, int background, char type, char *titre, int xt ,int yt,unsigned char valeur, char *texte)
{
  char* cptr;
  int taille;

  boite->win = XCreateSimpleWindow (display, win, x, y, largeur, hauteur, borderwidth, bordercolor, background);
  boite->x		= x;
  boite->y		= y;
  boite->largeur		= largeur;
  boite->hauteur		= hauteur;

  taille = strlen(titre);
  cptr = (char*)malloc(taille*sizeof(char)+1);
  strcpy(cptr,titre);
  boite->titre		= cptr;
  boite->xt		= xt;
  boite->yt		= yt;
  boite->taille1		= taille;

  switch(type)
    {
    case 'U': //boite de type UAL
      boite->eA = 0;
      boite->eB = 0;
      boite->op = nopp;
      boite->res =0;
      break;
    case 'T': //boite de type Texte
      taille = strlen(texte);
      cptr = (char*)malloc(taille*sizeof(char)+1);
      strcpy(cptr,texte);
      boite->texte		= cptr;
      boite->taille2		= taille;
      break;
    case 'N': //boite de type Normal
      boite->val = valeur;
      break;
    case 'R': // boite de type RAM
      boite->buffer = (unsigned char*)malloc(sizeof(unsigned char));
      //pour ne pas avoir de bug si on quitte sans charger la ram
      boite->status = 0;
      break;
    }
  boite->type = type;
}


//----------------------------------------------------------------------------------
// affiche une boite, d'apres ses caracteristiques
//----------------------------------------------------------------------------------
void Dessiner(BOITE *boite)
{
	unsigned char type = boite->type;
	char hex[3];
	char op[3];
	switch(type)
	{
		case 'T':
			XMapWindow (display, boite->win);
			XDrawString (display, boite->win, gc, 10, (int)(boite->hauteur/2)+5,boite->texte,boite->taille2);
			break;
		case 'U':
			XMapWindow (display, boite->win);
			switch(boite->op)
			  {
			  case nopp:
			    strcpy(op,"   ");
			    break;
			  case add:
			     strcpy(op," + ");
			     break;
			  case sub:
			     strcpy(op," - ");
			     break;
			  case mul:
			     strcpy(op," * ");
			     break;
			  case div:
			     strcpy(op," / ");
			     break;
			  case incra:
			     strcpy(op,"a+1");
			     break;
			  case incrb:
			     strcpy(op,"b+1");
			     break;
			  case decra:
			     strcpy(op,"a-1");
			     break;
			  case decrb:
			     strcpy(op,"b-1");
			     break;
			  case repa:
			     strcpy(op," a ");
			     break;
			  case repb:
			     strcpy(op," b ");
			     break;
			  }
			sprintf(hex,"%.2X",boite->eA);
			XDrawString (display, boite->win, gc, 10, 10,"A : ",4);
			XDrawString (display, boite->win, gc, 40,10,hex,2);
			sprintf(hex,"%.2X",boite->eB);
			XDrawString (display, boite->win, gc, boite->largeur-50,10,"B : ",4);
			XDrawString (display, boite->win, gc, boite->largeur-20,10,hex,2);
			XDrawString (display, boite->win, gc, (int)(boite->largeur/2)-5,(int)(boite->hauteur/2),op,3);
			sprintf(hex,"%.2X",boite->res);
			XDrawString (display, boite->win, gc, (int)(boite->largeur/2)-5,boite->hauteur-10,hex,2);
			break;
		case 'R':
			if(boite->status==0)
			{
				XMapWindow (display, boite->win);
				XDrawString (display, boite->win, gc, 10, (int)(boite->hauteur/2)+5,"RAM NON CHARGEE !!!",19);
			}
			else
			  {
			    int i,x,y=0;
			    char adr[3];
			    unsigned char *buffer;
			    buffer = boite->buffer;
			    XMapWindow (display, boite->win);
			    for(i=0;i<taille_RAM;i++)
			      {
				if((i % 8) == 0)
				  {
				    sprintf(adr,"%.2X",i);
				    XDrawString(display,boite->win,gc,5,y+10,adr,2);
				    XDrawString(display,boite->win,gc,17,y+10,":",1);
				    y+=10;
				    x=30;
				  }
				sprintf(adr,"%.2X",buffer[i]);
				XDrawString(display,boite->win,gc,x,y,adr,2);
				x+=15;
			      }
			  }
			break;
		case 'N':
			XMapWindow (display, boite->win);
			//Pour effacer le titre d'une boite on redessine un rectangle blanc par dessus
			XFillRectangle(display,win,gc3, boite->x+boite->xt-2, boite->y-(boite->yt-1)*10-1, boite->taille1*6+2, 10);
			XDrawString (display, win, gc, boite->x+boite->xt, boite->y-boite->yt, boite->titre,boite->taille1);
			sprintf(hex,"%.2X",boite->val);
			XDrawString (display, boite->win, gc, (int)(boite->largeur/2)-5, (int)(boite->hauteur/2)+5, hex,2);
			break;
	}
}


//----------------------------------------------------------------------------------
// dessine toutes les boites, et 1 rectangle autour de chaque partie de la machine
//----------------------------------------------------------------------------------
void Dessiner_Tous(BOITE* tab)
{
  int i;
  for(i=0;i<nb_boite;i++)
    Dessiner(&(tab[i]));
  XDrawRectangle(display,win,gc,5,125,250,300);
  XDrawRectangle(display,win,gc,270,350,250,195);
  XDrawRectangle(display,win,gc,535,125,250,300);
  XDrawRectangle(display,win,gc,270,30,250,195);
}


//----------------------------------------------------------------------------------
// efface et raffiche les boites
//----------------------------------------------------------------------------------
void refresh (BOITE* tab)
{
  int i;
  for(i=0;i<nb_boite;i++)
    {
      XUnmapWindow(display,tab[i].win);
      Dessiner(&(tab[i]));
    }
}


//----------------------------------------------------------------------------------
// liberation de la memoire allouee pour une boite
//----------------------------------------------------------------------------------
void detruireBoite(BOITE *boite)
{
  char type = boite->type;
  switch(type)
    {
    case 'T':
      free(boite->texte);
      break;
    case 'R':
      free(boite->buffer);
      break;
    default :
      break;
    }
  free(boite->titre);
}

//----------------------------------------------------------------------------------
// choix de la profondeur de couleurs : 8, 16, 24 ou 32 bits
//----------------------------------------------------------------------------------
void resolution(int choix)
{
	switch(choix)
	{
		case 49 : // 16 bits
			  rouge_1=55401; rouge_2=56601; rouge_3=56601;
	 		  bleu_1=25023; bleu_2=26301; bleu_3=26301;
	 		  vert_1=25824; vert_2=26517;
	 		  jaune_1=0x00FF00; jaune_2=0x00FF99;
			  bus_on=55401; bus_off=1;
			  break;
		case 56 :
		default : // 24 bits
			  rouge_1=0xFF0000; rouge_2=0xFF7777; rouge_3=0xFFAAAA;
	 		  bleu_1=0x0000FF; bleu_2=0x9999FF; bleu_3=0xBBBBFF;
	 		  vert_1=0x00FF00; vert_2=0xBBFFBB;
	 		  jaune_1=0xFFDD00; jaune_2=0xFFFF99;
			  bus_on=0xFF0000; bus_off=0x999999;
			  break;
	}
}

//----------------------------------------------------------------------------------
// Affiche des messages d'information a l'utilisateur
//----------------------------------------------------------------------------------

void ecrire_infos(INFOS *inf, int lequel)
{
	if((lequel==1)||(lequel==5))
	{
		XFillRectangle(display,win,gc3,45,390,100,20);
		XDrawString(display,win,gc2,50,400,inf->latence,strlen(inf->latence));
	}
	if((lequel==2)||(lequel==5))
	{
		XFillRectangle(display,win,gc3,45,475,150,20);
		XDrawString(display,win,gc4,50, 490, inf->instruction,strlen(inf->instruction));
	}
	if((lequel==3)||(lequel==5))
	{
		XFillRectangle(display,win,gc3,535,475,250,20);
		XDrawString(display,win,gc2,560,490,inf->saisie,strlen(inf->saisie));
	}
	if((lequel==4)||(lequel==5))
	{
		XFillRectangle(display,win,gc3,575,390,100,20);
		XDrawString(display,win,gc2,580,400,inf->lat_periph,strlen(inf->lat_periph));
	}
}


