#include "mnemo.h"

int main(int argc,char* argv[])
{
	if(argc!=3)
	{
		printf("\n\n-------------------------------------------------------------------------\n");
		printf("Veuillez entrer en parametre le chemin du fichier contenant le programme\n");
		printf("Et le nombre de bits pour la couleur\n");
		printf("-------------------------------------------\n");
		printf("Exemple : %s programme.von 24\n",argv[0]);
		printf("Exemple : %s programme.vnb 24\n",argv[0]);
		printf("-------------------------------------------\n\n");
	}
	else
	{
		int quitter = 0;
		int i;
		char verif_halt;
		unsigned long val_gc_masq;
		XGCValues gc_valeurs;

		BOITE tab[nb_boite];
		INFOS inf;
		int **mat;
		mat=(int**)malloc(nb_seg*sizeof(int*));
		for(i=0;i<nb_seg;i++)
			mat[i]=(int*)malloc(5*sizeof(int));
		if((display = XOpenDisplay("")) == NULL)
		{
			printf("%s","impossible de creer une fenetre\n");
			return 0;
		}
		gc = DefaultGC(display,screen);
		screen = DefaultScreen(display);
		root = RootWindow(display,screen);
		win = XCreateSimpleWindow (display, root,0, 0, 790, 590, 2, 0x000000, 0xFFFFFF);
		XSelectInput (display, win, ExposureMask | ButtonPressMask | KeyPressMask);
		XStoreName (display, win, "Machine de Von Neumann");
		XMapWindow (display, win);
		resolution(argv[2][0]);

		curs_fleche = XCreateFontCursor(display, XC_left_ptr);
		curs_main = XCreateFontCursor(display, XC_hand2);
		police = XLoadFont (display,"7x13bold");

		val_gc_masq = 0;                                                                // GC de base
		gc_valeurs.foreground = bus_off;
		val_gc_masq = val_gc_masq | GCForeground ;                                       //modifs de ce GC

		gc1 = XCreateGC (display, win, val_gc_masq, &gc_valeurs);                       //1erGC (fond "bus off", police normale)
		gc2 = XCreateGC (display, win, val_gc_masq, &gc_valeurs);                       //2e GC (fond rouge, police speciale)
		XSetForeground (display, gc2, bus_on);
		XSetFont(display,gc2,police);
		gc3 = XCreateGC (display, win, val_gc_masq, &gc_valeurs);                       //3e GC (fond blanc, police normale)
		XSetForeground (display, gc3, 0xFFFFFF);
		gc4 = XCreateGC (display, win, val_gc_masq, &gc_valeurs);                       //4e GC (fond noir, police speciale)
		XSetFont(display,gc4,police);
		XSetForeground(display, gc4, 0x000000);


		remplir_matrice(mat);

		strcpy(inf.latence, "");
		strcpy(inf.instruction, "");
		strcpy(inf.saisie, "");
		strcpy(inf.lat_periph, "");

		verif_halt = 0;


//----------------------------------------------------------------------------------
//CREATION DES BOITES
//----------------------------------------------------------------------------------


		creerBoite(&ACC_, 323,160, 80, 16,2,rouge_1,rouge_2,'N',"ACC",5,2,0,"");
		creerBoite(&UAL_, 288,60, 150, 75,2,rouge_1,rouge_2,'U',"UAL",5,2,0,"");
		creerBoite(&RC_,275,201,30,16,2,rouge_1,rouge_3,'N',"RC",5,2,0,"");
		creerBoite(&X_, 470,60, 42,16,2,rouge_1,rouge_2,'N',"X",5,2,0,"");
		creerBoite(&A_, 470,95, 42,16,2,rouge_1,rouge_3,'N',"A",5,2,0,"");
		creerBoite(&B_, 470,130, 42,16,2,rouge_1,rouge_3,'N',"B",5,2,0,"");
		creerBoite(&C_, 470,165,42,16,2,rouge_1,rouge_3,'N',"C",5,2,0,"");

		creerBoite(&RE_,     565,269,42,16,2,vert_1,vert_2,'N',"RE",5,2,0,"");
		creerBoite(&RSP_,    571,230,30,16,2,vert_1,vert_2,'N',"RSP",5,2,0,"");
		creerBoite(&CLAVIER_,637,175,120,44,2,vert_1,vert_2,'N',"Clavier",5,2,0,"");
		creerBoite(&ECRAN_,  637,255,120,44,2,vert_1,vert_2,'N',"Ecran",5,2,0,"");
		creerBoite(&PERIPH1_,637,335,120,44,2,vert_1,vert_2,'N',"Stockage",5,2,0,"");


		creerBoite(&PC_, 300,404,70,16,2,jaune_1,jaune_2,'N',"PC",5,2,0,"");
		creerBoite(&decodeur_,420,370,70,16,2,jaune_1,jaune_2,'T',"",5,2,0,"Decodeur");
		creerBoite(&RI_, 420,404,70,16,2,jaune_1,jaune_2,'N',"RI",5,2,0,"");
		creerBoite(&SP_, 300,475,70,16,2,jaune_1,jaune_2,'N',"SP",5,2,127,"");

		creerBoite(&RA_, 196,230,30,16,2,bleu_1,bleu_2,'N',"RA",5,2,0,"");
		creerBoite(&RM_,190,269,42,16,2,bleu_1,bleu_2,'N',"RM",5,2,0,"");
		creerBoite(&RAM_,15,192,152,162,2,bleu_1,bleu_3,'R',"RAM",5,2,0,"");//162

		creerBoite(&ldram_, 15,146,100,20,2,bleu_1,bleu_2,'T',"",0,0,0,"Charger la RAM");
		creerBoite(&cycle_, 360,518,70,16,2,jaune_1,jaune_2,'N',"Cycle    ",5,2,0,"");
		creerBoite(&quit_,  711,565,70,15,2,rouge_1,rouge_1,'T',"",0,0,0,"QUITTER");
		creerBoite(&surbrille_, 9000,0,12,8,1,bleu_1,bleu_3,'N',"",0,0,0,"");//9000 pour pas la voir au debut !
		creerBoite(&incdec_, 420,475,70,16,2,jaune_1,jaune_2,'N',"Incr/Decr",5,2,0,"");

		XSelectInput (display, ldram_.win, ExposureMask | ButtonPressMask | EnterWindowMask | LeaveWindowMask);
		XSelectInput (display, quit_.win, ExposureMask | ButtonPressMask | EnterWindowMask | LeaveWindowMask);
		XSelectInput (display, cycle_.win, ExposureMask | ButtonPressMask | EnterWindowMask | LeaveWindowMask);

//----------------------------------------------------------------------------------
//Boucle Evenements
//----------------------------------------------------------------------------------

		while(quitter == 0)
		{
			XEvent ev;
			XNextEvent (display, &ev);
			switch (ev.type)
			{
				case Expose :
					Dessiner_Tous(tab);
					affiche_tous_segments(mat);
					ecrire_infos(&inf,5);
					XDrawString(display,win,gc,240,570,"Realis par Axel Fournier & Paul Goergler - (C) 2002",52);
					break;

				case ButtonPress  :
					if ((ev.xbutton.window == ldram_.win)&&(RAM_.status==0)&&(verif_halt!=1))
					{
						free(ldram_.texte); //(1)
						if(loadRAM(&RAM_,argv[1])==1)
						{
							// pour afficher "RAM charge" on doit liberer l'espace (1)
							// recreer l'espace a la bonne dimension (2)
							// reinitialiser les variables du texte(3)
							ldram_.texte =(char*)malloc(sizeof(char)*11);//(2)
							ldram_.taille2 = 11; //(3)
							strcpy(ldram_.texte,"RAM charge");//(3)
							XDestroyWindow(display,surbrille_.win);
							surbrille_.win = XCreateSimpleWindow(display, RAM_.win,27,0,14,10,1,bleu_1,bleu_3);
							surbrille_.val = RAM_.buffer[0];
						}
						else
						{
							ldram_.taille2 = 14 ;
							ldram_.texte = (char*)malloc(sizeof(char)*14);
							strcpy(ldram_.texte,"Erreur fichier");
						}
						refresh(tab);
					}
					if((ev.xbutton.window == cycle_.win)&&(RAM_.status==1)&&(verif_halt!=1))
					{
						if(fetch(mat, tab, &inf)==0)
							quitter = 1;
						else
						quitter=!(decoder(tab,mat,&inf,&verif_halt));
					}
					if(ev.xbutton.window == quit_.win)
						quitter = 1;
					break;

				case KeyPress :
					if( ((ev.xkey.keycode==36) || (ev.xkey.keycode==108) || (ev.xkey.keycode==65) || (ev.xkey.keycode==104))&&(RAM_.status==1) )
					{
						if(fetch(mat, tab, &inf)==0)
							quitter =1;
						else
							quitter=!(decoder(tab,mat,&inf,&verif_halt));
					}
					break;

				case EnterNotify :
					if( ((ev.xbutton.window == cycle_.win)&&(RAM_.status==1)) ||((ev.xbutton.window == ldram_.win)&&(RAM_.status==0)&&(verif_halt!=1)) || (ev.xbutton.window == quit_.win) )
						XDefineCursor(display, win, curs_main);
					break;

				case LeaveNotify :
					if( (ev.xbutton.window == cycle_.win) ||(ev.xbutton.window == ldram_.win) || (ev.xbutton.window == quit_.win) )
						XDefineCursor(display, win, curs_fleche);
					break;

				default :
					break;
			}
		}

//----------------------------------------------------------------------------------
//destruction de la memoire
//----------------------------------------------------------------------------------

		for(i=nb_boite-1;i>=0;i--)//on fait a l'envers car si on detruit RAm avant de detruite la sous win surbrillance => pb
		{
			XDestroyWindow(display,tab[i].win); // detruite la mem allouer par XCreateSimpleWindow
			detruireBoite(&(tab[i]));
		}
		for(i=0;i<nb_seg;i++)
			free(mat[i]);
		free(mat);
		XUnloadFont (display,police);
		XFreeGC(display,gc);
		XFreeGC(display,gc1);
		XFreeGC(display,gc2);
		XFreeGC(display,gc3);
		XFreeGC(display,gc4);
		XDestroyWindow(display,win);
		XDestroyWindow(display,root);
	}
	return 0;
}

