#include "micro_op.h"

//----------------------------------------------------------------------------------
// Mise a Jour du registre de control
//----------------------------------------------------------------------------------
void maj_RC(BOITE* tab, int err)
{
	int res=err;
	XUnmapWindow(display,RC_.win);
	//teste si ACC <0
	if(ACC_.val>127)
		res+=8;
	//teste si acc == 0
	if(ACC_.val==0)
		res += 4;
	RC_.val = res;
	Dessiner(&RC_);
}

//----------------------------------------------------------------------------------
// Quelques micro operations et fonction de latence de la RAM
//----------------------------------------------------------------------------------

int PC_RA(BOITE* tab,int** mat)
{
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,3, 21,22,23);
	colorer_segment(mat,1,2,2,8);

	XUnmapWindow(display, RA_.win);
	RA_.val=PC_.val;
	Dessiner(&RA_);
	return 1;
}

int RA_RAM(BOITE* tab, int** mat,INFOS *inf)
{// RA ~~ RAM
	eteindre_tous_segments(mat);
	colorer_segment(mat,1,2, 52,56);
	surbrillance(tab,RA_.val);
	strcpy(inf->latence, " "); // espace qui indiquera a incdec d'afficher "Latence"
	ecrire_infos(inf,1);
	return 1;
}

int RAM_RM(BOITE* tab, int** mat,INFOS *inf)
{// RAM --> RM
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 0);

	XUnmapWindow(display, RM_.win);
	RM_.val=RAM_.buffer[RA_.val];
	Dessiner(&RM_);
	strcpy(inf->latence, "");
 	ecrire_infos(inf,1);
	return 1;
}

int RM_RAM(BOITE* tab, int** mat,INFOS* inf)  // 1ere etape de l'ecriture : activation du bus
{//RM->RAM[RA]
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,6, 0,52,53,54,55,56);
	strcpy(inf->latence, "Ecriture 0%");
	ecrire_infos(inf,1);
	surbrillance(tab,RA_.val);
	return 1;
}

int latence_ecr(BOITE *tab, int **mat, INFOS *inf)  // 2e etape de l'ecriture : simple latence
{
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 0);
	strcpy(inf->latence, "Ecriture 50%");
	ecrire_infos(inf,1);
	return 1;
}

int ecrire(BOITE* tab, int** mat, INFOS *inf)  // 3e etape de l'ecriture : affectation
{
	strcpy(inf->latence, "Ecriture 100%");
	ecrire_infos(inf,1);
	XUnmapWindow(display,RAM_.win);
	RAM_.buffer[RA_.val]=RM_.val;
	Dessiner(&RAM_);
	surbrillance(tab,RA_.val);
	return 1;

}

int RM_RA(BOITE* tab, int** mat)
{// RM --> RA
	eteindre_tous_segments(mat);
	XUnmapWindow(display,RA_.win);
	colorer_segment(mat,1,2, 1,4);

	RA_.val = RM_.val;
	Dessiner(&RA_);
	return 1;
}

int RM_ACC(BOITE* tab, int** mat)
{// RM --> ACC
	eteindre_tous_segments(mat);
	XUnmapWindow(display,ACC_.win);
	colorer_segment(mat,0,7, 1,2,5,6,28,29,30);
	ACC_.val = RM_.val;
	Dessiner(&ACC_);
	maj_RC(tab, 0);
	return 1;
}

int RM_eB(BOITE* tab, int** mat)
{//RM->eB
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,18, 1,2,5,6,28,29,38,47,46,45,44,43,42,41,40,39,37,36);

	XUnmapWindow(display, UAL_.win);
	UAL_.eB=RM_.val;
	Dessiner(&UAL_);
	return 1;
}

int reg_ACC(BOITE* tab, int** mat,int reg)
{//ACC <- reg
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,5,30,29,38,47,46);
	switch (reg)
	{
		case 1 : // on veut le contenu de A
			colorer_segment(mat,0,5,42,43,44,45,49);
			break;

		case 2 : // on veut le contenu de B
			colorer_segment(mat,0,3, 44,45,50);
			break;

		case 3 : // on veut le contenu de C
			colorer_segment(mat,0,1,51);
			break;

		default : // on veut le contenu de X
			colorer_segment(mat,0,7, 48,40,41,42,43,44,45);
			break;
	}
	XUnmapWindow(display, ACC_.win);
	ACC_.val=tab[reg+2].val;
	Dessiner(&ACC_);
	return 1;
}

int reg_eB(BOITE* tab,int** mat,int reg)
{// eB<-RegX
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,4,36,37,39,40);
	switch (reg)
	{
		case 1 : // on veut le contenu de A
			colorer_segment(mat,0,3,41,42,49);
			break;

		case 2 : // on veut le contenu de B
			colorer_segment(mat,0,5, 41,42,43,44,50);
			break;

		case 3 : // on veut le contenu de C
			colorer_segment(mat,0,7, 41,42,43,44,45,46,51);
			break;

		default : // on veut le contenu de X
			colorer_segment(mat,0,1, 48);
			break;
	}

	XUnmapWindow(display, UAL_.win);
	UAL_.eB=tab[reg+2].val;
	Dessiner(&UAL_);
	return 1;
}

int ACC_eA(BOITE* tab, int** mat)
{// eA<-ACC
	eteindre_tous_segments(mat);
	colorer_segment(mat,1,2, 32,35);

	XUnmapWindow(display, UAL_.win);
	UAL_.eA=ACC_.val;
	Dessiner(&UAL_);
	return 1;
}

int ACC_RM(BOITE* tab, int** mat)
{// bus RM-ACC   -   ACC<-RM
	eteindre_tous_segments(mat);
	XUnmapWindow(display, RM_.win);
	colorer_segment(mat,0,7, 30,29,28,6,5,2,1);
	RM_.val=ACC_.val;
	Dessiner(&RM_);
	maj_RC(tab, 0);
	return 1;
}

int ACC_RA(BOITE* tab, int** mat)
{// RA<-ACC
	eteindre_tous_segments(mat);
	XUnmapWindow(display, RA_.win);
	RA_.val=ACC_.val;
	Dessiner(&RA_);
	colorer_segment(mat,0,8, 30,29,28,6,5,2,4,3);
	return 1;
}

int ACC_reg(BOITE* tab, int** mat,int reg)
{// reg<-ACC
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,5, 30,29,38,47,46);

	switch (reg)
	{
		case 1 :// on affiche les bus du registre A
		  colorer_segment(mat,0,5, 42,43,44,45,49);
		  break;

		case 2 :// on affiche les bus du registre B
		  colorer_segment(mat,0,3, 44,45,50);
		  break;

		case 3 :// on affiche les bus du registre C
		  colorer_segment(mat,0,1, 51);
		  break;

		default:// on affiche les bus du registre X
		  colorer_segment(mat,0,7, 48,40,41,42,43,44,45);
		  break;
	}
	XUnmapWindow(display, tab[reg+2].win);
	tab[reg+2].val=ACC_.val;
	Dessiner(&tab[reg+2]);
	return 1;
}

