#include "mnemo.h"

int NOP(BOITE* tab, int** mat, INFOS *inf)
{
//NOP
	incr_cycle(tab);
	eteindre_tous_segments(mat);
	XUnmapWindow(display,cycle_.win);
	cycle_.val++;
	Dessiner(&cycle_);
	affiche_tous_segments(mat);
	return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int LOAD(BOITE* tab, int** mat, INFOS *inf)
{
// LOAD adr  : acc <- mem[adr]

//PC -> RA
	PC_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// RA ~~ RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// Incremente PC & RAM -> RM
	if(incdec(mat, tab, inf, 1,'+')==0)
		return 0;
// RM --> RA
	RM_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// RA ~~ RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//latence
	strcpy(inf->latence, "Latence");
	ecrire_infos(inf,1);
	eteindre_tous_segments(mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	strcpy(inf->latence, "");
	ecrire_infos(inf,1);

// RAM --> RM
	ecrire_infos(inf,1);
	RAM_RM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	//on a donc ici val dans RM

// RM --> ACC
	RM_ACC(tab,mat);
	incr_cycle(tab);return 1;
}
//------------------------------------------------------------------------------------------------------------------------------------------

int LDI(BOITE* tab, int** mat, INFOS *inf)
{
// LDI val  : acc <- val

//PC -> RA
	PC_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// RA ~~ RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// Incremente PC & RAM -> RM
	if(incdec(mat, tab, inf, 1,'+')==0)
		return 0;
// RM --> ACC
	RM_ACC(tab,mat);
	incr_cycle(tab);
	return 1;
}


//------------------------------------------------------------------------------------------------------------------------------------------


int LDXR (BOITE* tab, int** mat, INFOS *inf)
{
//LDXR reg
	unsigned char rm; // valeur de RM
	int err;
// lecture de reg et incrPC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//on a donc dans RM l'indice du registre a charger dans ACC

// RegX->eB
	reg_eB(tab,mat,0); // 0 pour dire qu'on charge le registre X
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//ACC <- reg
	rm = RM_.val;
	reg_ACC(tab,mat,rm);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// eA<-ACC
	UAL_.op=add;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul
	eteindre_tous_segments(mat);
	XUnmapWindow(display, UAL_.win);

	err=calc_ual(tab);
	Dessiner(&UAL_);

	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// ACC->RA
	ACC_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//latence
	strcpy(inf->latence, "Latence");
	ecrire_infos(inf,1);
	eteindre_tous_segments(mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;


// bus RAM-RM  -   RM<-RAM[RA]
	strcpy(inf->latence, "");
	ecrire_infos(inf,1);
	RAM_RM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// bus RM-ACC   -   ACC<-RM
	RM_ACC(tab,mat);
	incr_cycle(tab);return 1;
}


//------------------------------------------------------------------------------------------------------------------------------------------


int LDX (BOITE* tab, int** mat, INFOS *inf)
{
	int err;
//LDX adr

// lecture de adr et incrPC
	if(lect_incr(mat, tab, inf)==0)
		return 0;

// eB<-RegX
	reg_eB(tab,mat,0);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	//on a donc un cycle = temps de latence de la RAM

// bus RM-ACC   -   ACC<-RM
	RM_ACC(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// eA<-ACC
	UAL_.op=add;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);
	maj_RC(tab, err);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA<-ACC
	ACC_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// latence
	strcpy(inf->latence, "Latence");
	ecrire_infos(inf,1);
	eteindre_tous_segments(mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// bus RAM-RM  -   RM<-RAM[RA]
	RAM_RM(tab,mat,inf);
	strcpy(inf->latence, "");
 	ecrire_infos(inf,1);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// bus RM-ACC   -   ACC<-RM
	RM_ACC(tab,mat);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int LI(BOITE* tab, int** mat, INFOS *inf)
{
	int j;
//LI adr

// lecture de adr et incrPC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//on a donc adr dans RM

// 2 lectures (indirection)
	for(j=1;j<=2;j++)
	{
	// RM --> RA
		RM_RA(tab,mat);
		if(waitclick(mat, tab, inf, 0)==0)
			return 0;

	// RA~~RAM
		RA_RAM(tab,mat,inf);
		if(waitclick(mat, tab, inf, 0)==0)
			return 0;

	// latence
		strcpy(inf->latence, "Latence");
		ecrire_infos(inf,1);
		eteindre_tous_segments(mat);
		if(waitclick(mat, tab, inf, 0)==0)
			return 0;

	// bus RAM-RM  -   RM<-RAM[RA]
		strcpy(inf->latence, "");
		ecrire_infos(inf,1);
		RAM_RM(tab,mat,inf);
		if(waitclick(mat, tab, inf, 0)==0)
			return 0;
	}

// RM->ACC
	RM_ACC(tab,mat);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------
int MOVE(BOITE* tab, int** mat, INFOS *inf)
{
//MOVE reg1 reg2
	unsigned char reg1,reg2,temp;//pour eviter un acces aux structures et un echange
//lecture de reg1
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//on a donc ici reg1 dans RM
	reg1= RM_.val;
// PC->RA
	PC_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// RA~~RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// Incremente PC & RAM -> RM
	if(incdec(mat, tab, inf, 1,'+')==0)
		return 0; // pas bessoin d'attendre puisse que entre l'ordre de lecture et la lecture il c'est passe 1 phase
	//a la sortie de incdec on a lut dans la RAM et le resultat est dans RM
	reg2=RM_.val;

//affectation
	if(reg1!=regACC)
		XUnmapWindow(display,tab[reg1+2].win);
	else
		XUnmapWindow(display,ACC_.win);

	if((reg1!=regACC)&&(reg2!=regACC)) // car le registre ACC est apart
	{
		tab[reg1+2].val = tab[reg2+2].val;
		Dessiner(&tab[reg1+2]);
		//on fait +2 car l'indice de la boite X est 2.
	}
	else
	{
		if(reg1==regACC)
		{
			ACC_.val=tab[reg2+2].val;
			Dessiner(&ACC_);
		}
		else
		{
			tab[reg1+2].val=ACC_.val;
			Dessiner(&tab[reg1+2]);
		}
	}

	if(reg1>reg2)
	{
		temp=reg1;
		reg1=reg2;
		reg2=temp;
	}
	/*************************/
	/* pour surligner les bus*/
	eteindre_tous_segments(mat);
	if((reg1!=regACC)&&(reg2!=regACC))
	{
		colorer_segment(mat, 1,2,40+(reg1*2),40+(reg2*2)); // 40 +reg1 * 2 car pour regA->regB il faut allumer les segments 42 43 44
	}
	else
	{
		colorer_segment(mat, 0,4,30,29,38,47);
		if(reg1==regACC)
			colorer_segment(mat, 1,2,40+reg2*2,46);
		else
			colorer_segment(mat, 1,2,40+reg1*2,46);
	}
	if(reg1==regX || reg2 == regX)
		colorer_segment(mat,0,1,48);
	if(reg1==regA || reg2 == regA)
		colorer_segment(mat,0,1,49);
	if(reg1==regB || reg2 == regB)
		colorer_segment(mat,0,1,50);
	if(reg1==regC || reg2 == regC)
		colorer_segment(mat,0,1,51);
	affiche_tous_segments(mat);

	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int MVI(BOITE* tab, int** mat, INFOS *inf)
{
	unsigned char rm;
//MVI reg val

// lecture de reg et incrPC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	rm=RM_.val;

// lecture de val et incrPC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
// dans RM on a donc val

// reg<-val
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,8, 1,2,5,6,28,29,38,47);
	switch (rm)
	{
		case 1 : // on affiche les bus du registre A
			colorer_segment(mat,0,6, 42,43,44,45,46,49);
			break;

		case 2 : // on affiche les bus du registre B
			colorer_segment(mat,0,4, 44,45,46,50);
			break;

		case 3 : // on affiche les bus du registre C
			colorer_segment(mat,0,2, 46,51);
			break;

		default :
			colorer_segment(mat,0,8,40,41,42,43,44,45,46,48);
			break;
	}
	XUnmapWindow(display, tab[rm+2].win);
	tab[rm+2].val=RM_.val;
	Dessiner(&tab[rm+2]);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int STORE(BOITE* tab, int** mat, INFOS *inf)
{
//STORE adr

// lecture de adr et incrPC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//on a donc adr dans RM

// RM --> RA
	RM_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// ACC->RM
	ACC_RM(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM   et   bus RAM-RM
	RA_RAM(tab,mat,inf);
	strcpy(inf->latence, ""); // car il y avait " " a cause de RA_RAM
	ecrire_infos(inf,1);

// RM->RAM[RA] (ecriture (1))
	RM_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// latence (ecriture(2))
	latence_ecr(tab, mat, inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//ecrire (ecriture (3))
	ecrire(tab,mat,inf);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int STX(BOITE* tab, int** mat, INFOS *inf)
{
//STX adr
	int err;
// lecture de l'argument et incr PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//on a donc adr dans RM
// on fait RM->eb ,ACC->RM et regX->ACC car comme ca on ne perd pas le contenue de ACC

//RM->eB
	RM_eB(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//ACC->RM
	ACC_RM(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//regX->ACC
	reg_ACC(tab,mat,0);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//ACC->eA
	UAL_.op=add;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1,31);
	XUnmapWindow(display,UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);
	XUnmapWindow(display,ACC_.win);
	ACC_.val=UAL_.res;
	maj_RC(tab,err);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//ACC->RA
	ACC_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM   et   bus RAM-RM
	RA_RAM(tab,mat,inf);
	strcpy(inf->latence, ""); // car il y avait " " a cause de RA_RAM
	ecrire_infos(inf,1);

// RM->RAM[RA] (ecriture (1))
	RM_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// latence (ecriture(2))
	latence_ecr(tab, mat, inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//ecrire (ecriture (3))
	ecrire(tab,mat,inf);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------


int STXR(BOITE* tab, int** mat, INFOS *inf)
{
//STXR reg
	int err,reg;
// lecture de l'argument et incr PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//on a donc reg dans RM
	reg=RM_.val;
//ACC->RM
	ACC_RM(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//reg->ACC
	reg_ACC(tab,mat,reg);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//regX->eB
	reg_eB(tab,mat,0);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//ACC->eA
	UAL_.op=add;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1,31);
	XUnmapWindow(display,UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);
	XUnmapWindow(display,ACC_.win);
	ACC_.val=UAL_.res;
	maj_RC(tab,err);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//ACC->RA
	ACC_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM   et   bus RAM-RM
	RA_RAM(tab,mat,inf);
	strcpy(inf->latence, ""); // car il y avait " " a cause de RA_RAM
	ecrire_infos(inf,1);

// RM->RAM[RA] (ecriture (1))
	RM_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// latence (ecriture(2))
	latence_ecr(tab, mat, inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//ecrire (ecriture (3))
	ecrire(tab,mat,inf);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int JUMP(BOITE* tab, int** mat, INFOS *inf)
{
//JUMP adr
// lecture de l'argument et incr PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	// on a donc adr dans RM
//RM->PC
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,9 ,1,2,5,6,7,8,21,22,23);
	affiche_tous_segments(mat);
	XUnmapWindow(display,PC_.win);
	PC_.val = RM_.val;
	Dessiner(&PC_);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int JZ(BOITE* tab, int** mat, INFOS *inf)
{
// JZ adr
// lecture de l'argument et incr PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	// on a donc adr dans RM

	eteindre_tous_segments(mat);
	if((RC_.val&4)==4) // si dans x le bit 2 est a 1 => (X & 00000100)=00000100
	{
		//RM->PC
		colorer_segment(mat,0,9 ,1,2,5,6,7,8,21,22,23);
		affiche_tous_segments(mat);
		XUnmapWindow(display,PC_.win);
		PC_.val = RM_.val;
		Dessiner(&PC_);
	}
	incr_cycle(tab);return 1;

}

//------------------------------------------------------------------------------------------------------------------------------------------

int JNZ(BOITE* tab, int** mat, INFOS *inf)
{
// JNZ adr
// lecture de l'argument et incr PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	// on a donc adr dans RM


	eteindre_tous_segments(mat);
	if((RC_.val&4)!=4)
	{
		//RM->PC
		colorer_segment(mat,0,9 ,1,2,5,6,7,8,21,22,23);
		affiche_tous_segments(mat);
		XUnmapWindow(display,PC_.win);
		PC_.val = RM_.val;
		Dessiner(&PC_);
	}
	incr_cycle(tab);return 1;

}

//------------------------------------------------------------------------------------------------------------------------------------------

int JP(BOITE* tab, int** mat, INFOS *inf)
{
// JP adr
// lecture de l'argument et incr PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	// on a donc adr dans RM


	eteindre_tous_segments(mat);
	if((RC_.val&8)!=8)
	{
		//RM->PC
		colorer_segment(mat,0,9 ,1,2,5,6,7,8,21,22,23);
		affiche_tous_segments(mat);
		XUnmapWindow(display,PC_.win);
		PC_.val = RM_.val;
		Dessiner(&PC_);
	}
	incr_cycle(tab);return 1;

}

//------------------------------------------------------------------------------------------------------------------------------------------

int JNP(BOITE* tab, int** mat, INFOS *inf)
{
// JNP adr
// lecture de l'argument et incr PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	// on a donc adr dans RM

	eteindre_tous_segments(mat);
	if((RC_.val&8)==8)
	{
		//RM->PC
		colorer_segment(mat,0,9 ,1,2,5,6,7,8,21,22,23);
		affiche_tous_segments(mat);
		XUnmapWindow(display,PC_.win);
		PC_.val = RM_.val;
		Dessiner(&PC_);
	}
	incr_cycle(tab);return 1;

}

//------------------------------------------------------------------------------------------------------------------------------------------
int ADD(BOITE* tab, int** mat, INFOS *inf)
{
	int err;
//ADD adr

//lecture de val
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc adr

// RM --> RA
	RM_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM   et   bus RAM-RM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//latence un cycle
// eA<-ACC
	ACC_eA(tab,mat);
	strcpy(inf->latence, "Latence");
	ecrire_infos(inf, 1);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// bus RAM-RM  -   RM<-RAM[RA]
	ACC_eA(tab,mat);
	strcpy(inf->latence, "");
	ecrire_infos(inf, 1);
	RAM_RM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//eB <- RM
	ACC_eA(tab,mat);
	UAL_.op=add;
	RM_eB(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;


// Calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}


//------------------------------------------------------------------------------------------------------------------------------------------

int ADI(BOITE* tab, int** mat, INFOS *inf)
{
	int err;
//ADI val

// lecture de val
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc val

// eA<-ACC   et   eB<-RM
	UAL_.op=add;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	RM_eB(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int ADR(BOITE* tab, int** mat, INFOS *inf)
{
	unsigned char rm;
	int err;

// ADR reg

//lecture de reg et incrementation de PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc reg
	rm=RM_.val;

// eA<-ACC   et   eB<-reg
	UAL_.op=add;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	reg_eB(tab,mat,rm);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}



//------------------------------------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------------------------------------

int SUB(BOITE* tab, int** mat, INFOS *inf)
{
	int err;
//SUB adr

//lecture de val
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc adr

// RM --> RA
	RM_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM   et   bus RAM-RM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//latence un cycle
// eA<-ACC
	ACC_eA(tab,mat);
	strcpy(inf->latence, "Latence");
	ecrire_infos(inf,1);
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// bus RAM-RM  -   RM<-RAM[RA]
	ACC_eA(tab,mat);
	strcpy(inf->latence, "");
	ecrire_infos(inf,1);
	RAM_RM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//eB <- RM
	UAL_.op=sub;
	RM_eB(tab,mat);;
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;


// Calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}


//------------------------------------------------------------------------------------------------------------------------------------------

int SUI(BOITE* tab, int** mat, INFOS *inf)
{
	int err;
//SUI val

// lecture de val
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc val

// eA<-ACC   et   eB<-RM
	UAL_.op=sub;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	RM_eB(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int SUR(BOITE* tab, int** mat, INFOS *inf)
{
	unsigned char rm;
	int err;

// SUBR reg

//lecture de reg et incrementation de PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc reg
	rm=RM_.val;

// eA<-ACC   et   eB<-reg
	UAL_.op=sub;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	reg_eB(tab,mat,rm);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}



//------------------------------------------------------------------------------------------------------------------------------------------

int MUL(BOITE* tab, int** mat, INFOS *inf)
{
	int err;
//MUL adr

//lecture de val
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc adr

// RM --> RA
	RM_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM   et   bus RAM-RM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//latence un cycle
// eA<-ACC
	ACC_eA(tab,mat);
	strcpy(inf->latence, "Latence");
	ecrire_infos(inf, 1);
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// bus RAM-RM  -   RM<-RAM[RA]
	strcpy(inf->latence, "");
	ecrire_infos(inf, 1);
	RAM_RM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//eB <- RM
	ACC_eA(tab,mat);
	UAL_.op=mul;
	RM_eB(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;


// Calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}


//------------------------------------------------------------------------------------------------------------------------------------------

int MUI(BOITE* tab, int** mat, INFOS *inf)
{
	int err;
//MUI val

// lecture de val
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc val

// eA<-ACC   et   eB<-RM
	UAL_.op=mul;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	RM_eB(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int MUR(BOITE* tab, int** mat, INFOS *inf)
{
	unsigned char rm;
	int err;

// MUR reg

//lecture de reg et incrementation de PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc reg
	rm=RM_.val;

// eA<-ACC   et   eB<-reg
	UAL_.op=mul;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	reg_eB(tab,mat,rm);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul

	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}



//------------------------------------------------------------------------------------------------------------------------------------------

int DIV(BOITE* tab, int** mat, INFOS *inf)
{
	int err;
//DIV adr

//lecture de val
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc adr

// RM --> RA
	RM_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM   et   bus RAM-RM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//latence un cycle
// eA<-ACC
	ACC_eA(tab,mat);
	strcpy(inf->latence, "Latence");
	ecrire_infos(inf, 1);
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// bus RAM-RM  -   RM<-RAM[RA]
	strcpy(inf->latence, "");
	ecrire_infos(inf, 1);
	RAM_RM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//eB <- RM
	UAL_.op=div;
	RM_eB(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;


// Calcul

	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}


//------------------------------------------------------------------------------------------------------------------------------------------

int DIVI(BOITE* tab, int** mat, INFOS *inf)
{
	int err;
//DIVI val

// lecture de val
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc val

// eA<-ACC   et   eB<-RM
	UAL_.op=div;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	RM_eB(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul

	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int DIVR(BOITE* tab, int** mat, INFOS *inf)
{
	unsigned char rm;
	int err;

// DIVR reg

//lecture de reg et incrementation de PC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//dans RM on a donc reg
	rm=RM_.val;

// eA<-ACC   et   eB<-reg
	UAL_.op=div;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	reg_eB(tab,mat,rm);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul

	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}



//------------------------------------------------------------------------------------------------------------------------------------------

int INC(BOITE* tab, int** mat, INFOS *inf)
{
	int err;

//INC

// eA<-ACC
	UAL_.op=incra;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul

	eteindre_tous_segments(mat);
	colorer_segment(mat,0,1, 31);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}

int DEC(BOITE* tab, int** mat, INFOS *inf)
{
	int err;

//DEC

// eA<-ACC
	UAL_.op=decra;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul

	eteindre_tous_segments(mat);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	colorer_segment(mat,0,1, 31);
	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}



//------------------------------------------------------------------------------------------------------------------------------------------

int INCR(BOITE* tab, int** mat, INFOS *inf)
{
	unsigned char rm;
	int err;

//INCR reg

	if(lect_incr(mat, tab, inf)==0)
		return 0;
	rm=RM_.val;

// eB<-reg
	UAL_.op=incrb;
	reg_eB(tab,mat,rm);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul

	eteindre_tous_segments(mat);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	colorer_segment(mat,0,1, 31);
	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);

	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// reg<-ACC
	ACC_reg(tab,mat,rm);
	incr_cycle(tab);return 1;
}






//------------------------------------------------------------------------------------------------------------------------------------------


int DECR(BOITE* tab, int** mat, INFOS *inf)
{
	unsigned char rm;
	int err;

//DECR  reg

//lecture de l'indice du registre
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	rm=RM_.val;

// eB<-reg
	UAL_.op=decrb;
	reg_eB(tab,mat,rm);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Calcul

	eteindre_tous_segments(mat);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	colorer_segment(mat,0,1, 31);
	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);

	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// reg<-ACC
	ACC_reg(tab,mat,rm);
	incr_cycle(tab);return 1;
}


//------------------------------------------------------------------------------------------------------------------------------------------

int CMP(BOITE* tab, int** mat, INFOS *inf)
{
	int reg1, reg2, err;
// CMP reg1 reg2

//lecture de reg1!
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	reg1=RM_.val;
//lecture de reg2
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	reg2=RM_.val;
//reg1->eB
	reg_eB(tab,mat,reg1);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//reg2->ACC
	reg_ACC(tab,mat,reg2);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//ACC->eA
	UAL_.op=sub;
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// Calcul

	eteindre_tous_segments(mat);

	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	colorer_segment(mat,0,1, 31);
	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);

	incr_cycle(tab);return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------
int CALL(BOITE* tab, int** mat, INFOS *inf)
{
// CALL adr
	int err;

//lecture de adr
	if(lect_incr(mat, tab, inf)==0)
		return 0;
	//on a donc adr dans RM et PC pointe vers la mnemonique suivante
//ACC->eA // pour sauvegarder ACC
	ACC_eA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//RM->ACC pour sauvegarder adr
	RM_ACC(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//SP->RA

	eteindre_tous_segments(mat);
	XUnmapWindow(display,RA_.win);
	colorer_segment(mat,0, 12,24,67,27,22,21,8,7,6,5,2,4,3);
	RA_.val=SP_.val;
	Dessiner(&RA_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//PC->RM

	eteindre_tous_segments(mat);
	XUnmapWindow(display,RM_.win);
	colorer_segment(mat,0, 9,1,2,5,6,7,8,21,22,23);
	RM_.val=PC_.val;
	Dessiner(&RM_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

	if(incdec(mat,tab,inf,2,'-')==0) // on incremente SP
		return 0;

//on a donc ecrit PC dans la pile

//ACC->PC

	eteindre_tous_segments(mat);
	XUnmapWindow(display,PC_.win);
	colorer_segment(mat,0, 9,30,29,28,6,7,8,21,22,23);
	PC_.val =ACC_.val;
	Dessiner(&PC_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//repA on recupere l'ancienne valeur de ACC

	eteindre_tous_segments(mat);
	UAL_.op=repa;
	XUnmapWindow(display, UAL_.win);
	err=calc_ual(tab);
	Dessiner(&UAL_);

	colorer_segment(mat,0,1, 31);
	XUnmapWindow(display, ACC_.win);
	ACC_.val=UAL_.res;
	Dessiner(&ACC_);

	maj_RC(tab, err);
	incr_cycle(tab);return 1;
}

//-------------------------------------------------------------------------------------------------------------------------------

int PUSH(BOITE* tab,int** mat, INFOS *inf)
{
//SP->RA

	eteindre_tous_segments(mat);
	XUnmapWindow(display,RA_.win);
	colorer_segment(mat,0, 12,24,67,27,22,21,8,7,6,5,2,4,3);
	RA_.val=SP_.val;
	Dessiner(&RA_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// ACC->RM
	ACC_RM(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//incremente SP
	if(incdec(mat,tab,inf,2,'-')==0) // on incremente SP
		return 0;
	incr_cycle(tab);
	return 1;
}


//-------------------------------------------------------------------------------------------------------------------------------

int POP(BOITE* tab,int** mat, INFOS *inf)
{
//decremente SP
	if(incdec(mat,tab,inf,2,'+')==0) // on decremente SP
		return 0;

//SP->RA

	eteindre_tous_segments(mat);
	XUnmapWindow(display,RA_.win);
	colorer_segment(mat,0, 12,24,67,27,22,21,8,7,6,5,2,4,3);
	RA_.val=SP_.val;
	Dessiner(&RA_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA ~~ RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//latence

	strcpy(inf->latence, "Latence");
 	ecrire_infos(inf,1);
	eteindre_tous_segments(mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	strcpy(inf->latence, "");
 	ecrire_infos(inf,1);


// RAM --> RM
	ecrire_infos(inf,1);
	RAM_RM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
	//on a donc ici val dans RM

// RM --> ACC
	RM_ACC(tab,mat);
	incr_cycle(tab);
	return 1;
}

//------------------------------------------------------------------------------------------------------------------------------------------

int RETURN(BOITE* tab, int** mat, INFOS *inf)
{
// RETURN

//decremente SP
	if(incdec(mat,tab,inf,2,'+')==0) // on decremente SP
		return 0;
//SP->RA

	eteindre_tous_segments(mat);
	XUnmapWindow(display,RA_.win);
	colorer_segment(mat,0, 12,24,67,27,22,21,8,7,6,5,2,4,3);
	RA_.val=SP_.val;
	Dessiner(&RA_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//RA~~RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//latence

	strcpy(inf->latence, "Latence");
	ecrire_infos(inf, 1);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//RAM->RM
	RAM_RM(tab,mat,inf);
	strcpy(inf->latence, "");
	ecrire_infos(inf, 1);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
//on a donc adr dans RM
//RM->PC

	eteindre_tous_segments(mat);
	XUnmapWindow(display,PC_.win);
	colorer_segment(mat,0, 9,1,2,5,6,7,8,21,22,23);
	PC_.val=RM_.val;
	Dessiner(&PC_);
	incr_cycle(tab);return 1;
}
//------------------------------------------------------------------------------------------------------------------------------------------

int LDP(BOITE* tab, int** mat, INFOS *inf)
{
	int c;
//lecture de l'indice du peripherique
	if(lect_incr(mat, tab, inf)==0)
		return 0;

// RM->RSP

	eteindre_tous_segments(mat);
	XUnmapWindow(display,RSP_.win);
	colorer_segment(mat,0,10, 1,2,5,6,7,8,9,10,12,13);
	RSP_.val = RM_.val;
	Dessiner(&RSP_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// selection peripherique

	eteindre_tous_segments(mat);
	colorer_segment(mat,1,2, 57,61);
	c = ( (RSP_.val==1) ? 1 : 0); // si c'est le clavier, il y aura attente de saisie dans le waitclick
	if(waitclick(mat, tab, inf, c)==0)
		return 0;

// latence

	eteindre_tous_segments(mat);
	strcpy(inf->lat_periph, "Latence");
	ecrire_infos(inf,4);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// periph->RE

	eteindre_tous_segments(mat);
	strcpy(inf->lat_periph, "");
	ecrire_infos(inf,4);
	switch (RSP_.val)
	{
		case 1 : // on affiche les bus du clavier
		  colorer_segment(mat,0,4, 14,15,17,19);
		  break;

		case 3 : // on affiche les bus du periph de stockage
		  colorer_segment(mat,0,4, 14,15,18,20);
		  break;

		default : // sinon l'ecran
			colorer_segment(mat,0,3,14,15,16);
			break;
	}
	XUnmapWindow(display,RE_.win);
	RE_.val = tab[7+RSP_.val].val; // car clavier "1" = tab[8], ecran "2" = tab[9]...
	Dessiner(&RE_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// ACC<-RE

	eteindre_tous_segments(mat);
	XUnmapWindow(display, ACC_.win);
	colorer_segment(mat,0,9, 11,10,9,8,7,6,28,29,30);
	ACC_.val=RE_.val;
	Dessiner(&ACC_);
	maj_RC(tab, 0);

	incr_cycle(tab);return 1;
}



//------------------------------------------------------------------------------------------------------------------------------------------

int STP(BOITE* tab, int** mat, INFOS *inf)
{
//lecture de l'indice du peripherique
	if(lect_incr(mat, tab, inf)==0)
		return 0;

// RM->RSP

	eteindre_tous_segments(mat);
	XUnmapWindow(display,RSP_.win);
	colorer_segment(mat,0,10, 1,2,5,6,7,8,9,10,12,13);
	RSP_.val = RM_.val;
	Dessiner(&RSP_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// ACC->RE

	eteindre_tous_segments(mat);
	XUnmapWindow(display, RE_.win);
	colorer_segment(mat,0,9, 11,10,9,8,7,6,28,29,30);
	RE_.val=ACC_.val;
	Dessiner(&RE_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// selection peripherique

	eteindre_tous_segments(mat);
	strcpy(inf->lat_periph, "Ecriture 0%");
	ecrire_infos(inf,4);
	colorer_segment(mat,1,2, 57,61);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RE->periph

	eteindre_tous_segments(mat);
	strcpy(inf->lat_periph, "Ecriture 50 %");
	ecrire_infos(inf,4);
	switch (RSP_.val)
	{
		case 2 : // on affiche les bus de l'ecran
		  colorer_segment(mat,1,2, 14,16);
		  break;

		case 3 : // on affiche les bus du periph de stockage
		  colorer_segment(mat,0,4, 14,15,18,20);
		  break;

		default : //on ne peut pas ecrire dans le clavier
		  break;
	}
	if(waitclick(mat, tab, inf, 0)==0)
	return 0;

// ecriture

	strcpy(inf->lat_periph, "Ecriture 100%");
	ecrire_infos(inf,4);
	XUnmapWindow(display,tab[7+RSP_.val].win);
	tab[7+RSP_.val].val = RE_.val; // car clavier "1" = tab[8], ecran "2" = tab[9]...
	Dessiner(&tab[7+RSP_.val]);

	incr_cycle(tab);return 1;
}

//----------------------------------------------------------------------------------------------------------------------------------

int STI(BOITE *tab, int **mat, INFOS *inf)
{//STI adr

// lecture de adr et incrPC
	if(lect_incr(mat, tab, inf)==0)
		return 0;
//on a donc adr dans RM

// RM --> RA
	RM_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// latence

	eteindre_tous_segments(mat);
	strcpy(inf->latence, "Latence");
	ecrire_infos(inf,1);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// bus RAM-RM  -   RM<-RAM[RA]
	strcpy(inf->latence, "");
	ecrire_infos(inf,1);
	RAM_RM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;
// ici, RM contient Mem[adr]

// RM --> RA
	RM_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// ACC->RM
	ACC_RM(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RM->RAM[RA] (ecriture (1))
	RM_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// latence (ecriture(2))
	latence_ecr(tab, mat, inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

//ecrire (ecriture (3))
	ecrire(tab,mat,inf);
	incr_cycle(tab);return 1;
}



//------------------------------------------------------------------------------------------------------------------------------------------




int decoder(BOITE* tab, int** mat, INFOS *inf, char *verif_halt)
{
	int mnemo,quit=1;
	mnemo = RI_.val;
	switch(mnemo)
	{
		case load_ :
			strcpy(inf->instruction, "LOAD adr");
			ecrire_infos(inf,2);
			quit=LOAD(tab,mat,inf);
			break;
		case ldi_ :
			strcpy(inf->instruction, "LDI val");
			ecrire_infos(inf,2);
			quit=LDI(tab,mat,inf);
			break;
		case ldxr_ :
			strcpy(inf->instruction, "LDXR reg");
			ecrire_infos(inf,2);
			quit=LDXR(tab,mat,inf);
			break;
		case ldx_ :
			strcpy(inf->instruction, "LDX adr");
			ecrire_infos(inf,2);
			quit=LDX(tab,mat,inf);
			break;
		case li_ :
			strcpy(inf->instruction, "LI adr");
			ecrire_infos(inf,2);
			quit=LI(tab,mat,inf);
			break;
		case move_ :
			strcpy(inf->instruction, "MOVE reg1 reg2");
			ecrire_infos(inf,2);
			quit=MOVE(tab,mat,inf);
			break;
		case mvi_ :
			strcpy(inf->instruction, "MVI reg val");
			ecrire_infos(inf,2);
			quit=MVI(tab,mat,inf);
			break;
		case store_ :
			strcpy(inf->instruction, "STORE adr");
			ecrire_infos(inf,2);
			quit=STORE(tab,mat,inf);
			break;
		case stx_ :
			strcpy(inf->instruction, "STX adr");
			ecrire_infos(inf,2);
			quit=STX(tab,mat,inf);
			break;
		case stxr_ :
			strcpy(inf->instruction, "STXR reg");
			ecrire_infos(inf,2);
			quit=STXR(tab,mat,inf);
			break;
		case jump_ :
			strcpy(inf->instruction, "JUMP adr");
			ecrire_infos(inf,2);
			quit=JUMP(tab,mat,inf);
			break;
		case jz_ :
			strcpy(inf->instruction, "JZ adr");
			ecrire_infos(inf,2);
			quit=JZ(tab,mat,inf);
			break;
		case jnz_ :
			strcpy(inf->instruction, "JNZ adr");
			ecrire_infos(inf,2);
			quit=JNZ(tab,mat,inf);
			break;
		case jp_ :
			strcpy(inf->instruction, "JP adr");
			ecrire_infos(inf,2);
			quit=JP(tab,mat,inf);
			break;
		case jnp_ :
			strcpy(inf->instruction, "JNP adr");
			ecrire_infos(inf,2);
			quit=JNP(tab,mat,inf);
			break;
		case add_ :
			strcpy(inf->instruction, "ADD adr");
			ecrire_infos(inf,2);
			quit=ADD(tab,mat,inf);
			break;
		case adi_ :
			strcpy(inf->instruction, "ADI val");
			ecrire_infos(inf,2);
			quit=ADI(tab,mat,inf);
			break;
		case adr_ :
			strcpy(inf->instruction, "ADR reg");
   			ecrire_infos(inf,2);
			quit=ADR(tab,mat,inf);
			break;
		case sub_ :
			strcpy(inf->instruction, "SUB adr");
			ecrire_infos(inf,2);
			quit=SUB(tab,mat,inf);
			break;
		case sui_ :
			strcpy(inf->instruction, "SUI val");
			ecrire_infos(inf,2);
			quit=SUI(tab,mat,inf);
			break;
		case sur_ :
			strcpy(inf->instruction, "SUR reg");
			ecrire_infos(inf,2);
			quit=SUR(tab,mat,inf);
			break;
		case mul_ :
			strcpy(inf->instruction, "MUL adr");
			ecrire_infos(inf,2);
			quit=MUL(tab,mat,inf);
			break;
		case mui_ :
			strcpy(inf->instruction, "MUI val");
			ecrire_infos(inf,2);
			quit=MUI(tab,mat,inf);
			break;
		case mur_ :
			strcpy(inf->instruction, "MUR reg");
			ecrire_infos(inf,2);
			quit=MUR(tab,mat,inf);
			break;
		case div_ :
			strcpy(inf->instruction, "DIV adr");
			ecrire_infos(inf,2);
			quit=DIV(tab,mat,inf);
			break;
  		case divi_ :
			strcpy(inf->instruction, "DIVI val");
			ecrire_infos(inf,2);
			quit=DIVI(tab,mat,inf);
			break;
		case divr_ :
			strcpy(inf->instruction, "DIVR reg");
			ecrire_infos(inf,2);
			quit=DIVR(tab,mat,inf);
			break;
		case inc_ :
			strcpy(inf->instruction, "INC");
			ecrire_infos(inf,2);
			quit=INC(tab,mat,inf);
			break;
		case dec_ :
			strcpy(inf->instruction, "DEC");
			ecrire_infos(inf,2);
			quit=DEC(tab,mat,inf);
			break;
		case incr_ :
			strcpy(inf->instruction, "INCR reg");
			ecrire_infos(inf,2);
			quit=INCR(tab,mat,inf);
			break;
		case decr_ :
			strcpy(inf->instruction, "DECR reg");
			ecrire_infos(inf,2);
			quit=DECR(tab,mat,inf);
			break;
		case cmp_ :
			strcpy(inf->instruction, "CMP reg1 reg2");
			ecrire_infos(inf,2);
			quit=CMP(tab,mat,inf);
			break;
		case call_ :
			strcpy(inf->instruction, "CALL adr");
			ecrire_infos(inf,2);
			quit=CALL(tab,mat,inf);
			break;
		case return_ :
			strcpy(inf->instruction, "RETURN");
			ecrire_infos(inf,2);
			quit=RETURN(tab,mat,inf);
			break;
		case halt_ :
			strcpy(inf->instruction, "HALT");
			ecrire_infos(inf,2);
			quit=1;*verif_halt=1;
			RAM_.status=0;
			break;
		case ldp_:
			strcpy(inf->instruction, "LDP pph");
			ecrire_infos(inf,2);
			quit=LDP(tab,mat,inf);
			break;
		case stp_:
			strcpy(inf->instruction, "STP pph");
			ecrire_infos(inf,2);
			quit=STP(tab,mat,inf);
			break;
		case sti_:
			strcpy(inf->instruction, "STI adr");
			ecrire_infos(inf,2);
			quit=STI(tab,mat,inf);
			break;
		case push_:
			strcpy(inf->instruction, "PUSH");
			ecrire_infos(inf,2);
			quit=PUSH(tab,mat,inf);
			break;
		case pop_:
			strcpy(inf->instruction, "POP");
			ecrire_infos(inf,2);
			quit=POP(tab,mat,inf);
			break;
		default: // en mettant NOP par defaut cela evite d'avoir un bug si la compilation c'est mal passer <=> programme mal ecrit
			strcpy(inf->instruction, "NOP");
			ecrire_infos(inf,2);
			quit=NOP(tab,mat,inf);
			break;
	}
	return quit;
}








