#include "util_mnemo.h"






//----------------------------------------------------------------------------------
// calcule le champ resultat de la boite UAL
//----------------------------------------------------------------------------------
int calc_ual(BOITE *tab)
{
  unsigned char a=UAL_.eA;
  unsigned char b=UAL_.eB;
  unsigned char res,vaa,vab; //resultat de l'operation
  int int_res;
  int sa,sb,sign;  // pos_a et b sont les signe de a et de b
  int err=0;

  sa = ((a>127) ? 1 : 0);
  sb = ((b>127) ? 1 : 0);
  sign=sa+sb; // 0 si "++", 1 si "+-", 2 si "--"
  if (a==b)
	err=2; // indique l'egalite des 2 entrees

  switch(UAL_.op)
    {
	case nopp:
		break;

	case add:
		res = a + b;
		int_res = a + b;
		if ((sign==0)&&(res>127))  // 2 positifs et debordement
			err+=1;
		if ((sign==2)&&(res<128))  // 2 negatifs et debordement
			err+=1;
		break;

	case sub:
		res = a - b;
		int_res = a - b;
		if ((sa==0)&&(sb==1)&&(res>127))  // 1 pos moins 1 neg et debordement
			err+=1;
		if ((sa==1)&&(sb==0)&&(res<128))  // 1 neg moins un pos et debordement
			err+=1;
		break;

	case mul:
		vaa = ((sa==1) ? (256-a) : a); // valeur absolue, dc entre 0 et 127
		vab = ((sb==1) ? (256-b) : b);
		int_res = vaa * vab; // servira a tester le debordement
		if(int_res>127) // debordement, test sur le int et non pas sur le u.char
			err+=1;

		res = (unsigned char)(vaa*vab); // produit des valeurs abs.
		if(sign==1)
			res=(unsigned char)(256-res); // eventuellement, changt de signe
		break;

	case div:
		if(b==0)
		{
			err+=16; //indication de l'erreur, comme un debordement
			res = 0;
		}
		else
		{
			vaa = ((sa==1) ? (256-a) : a); // valeur absolue, dc entre 0 et 127
			vab = ((sb==1) ? (256-b) : b);
			res = (unsigned char)(vaa /vab);
			if(sign==1)
				res=(unsigned char)(256-res); // negatif
		}
		break;

	case incra:
		res = a + 1;
		if(a==127) // un positif +1 = un negitif => une erreur
			err+=1;
		break;

	case incrb:
		res = b + 1;
		if(b==127) // un positif +1 = un negitif => une erreur
			err+=1;
		break;

	case decra:
		res = a - 1;
		if(a==128) // un negatif -1 = un positif => une erreur
			err+=1;
		break;

	case decrb:
		res = b - 1;
		if(a==128)
			err+=1;
		break;

	case repa :
		res = a;
		break;

	case repb :
		res = b;
		break;
    }
    UAL_.res=res;
    return err;
}

//----------------------------------------------------------------------------------
// dit si la touche presse est 0...A...F (hexadecimal)
//----------------------------------------------------------------------------------
int touche_valide(int k)
{
	return( (k==90) || (k==87) || (k==88) || (k==89) || (k==83) || (k==84) || (k==85) || (k==79) || (k==80) || (k==81)
		|| (k==24) || (k==56) || (k==54)|| (k==40) || (k==26) || (k==41) );
}



//----------------------------------------------------------------------------------
// attente entre chaque cycle d'une mnmonique
// gre, si besoin est, l'entre d'une valeur au clavier
//----------------------------------------------------------------------------------
int waitclick(int **mat, BOITE *tab, INFOS *inf, int c)
{
	int a=0, raz_chaine=1;
	int b=1;
	int saisie_effectuee = ((c==0) ? 1 : 0);
	char chaine[10];
	char caract;
	if(c==1)
	{
		strcpy(inf->saisie, "Entrez une valeur au clavier");
		ecrire_infos(inf,3);
	}
	incr_cycle(tab);
	while(a!=1)
	{
		KeySym symbole;
		XEvent ev;
		XNextEvent (display, &ev);
		switch (ev.type)
		{
			case ButtonPress :
				if((ev.xbutton.window == cycle_.win)&&(saisie_effectuee==1))
					a=1;
				if(ev.xbutton.window == quit_.win)
				{
					a=1;
					b=0;
				}
				break; // => sortie du waitclick

			 case Expose :
	      			Dessiner_Tous(tab);
	      			affiche_tous_segments(mat);
				ecrire_infos(inf,5);
				XDrawString(display,win,gc,240,570,"Realis par Axel Fournier & Paul Goergler - (C) 2002",52);
				break; // => cas d'un reaffichage

			case KeyPress :
				//nouveau cycle
				if( ((ev.xkey.keycode==36)||(ev.xkey.keycode==108)||(ev.xkey.keycode==65)||(ev.xkey.keycode==104)) && (saisie_effectuee==1))
					a=1;
				else
				// entree au clavier
				{
					if((raz_chaine==1)&&(c==1)) //nouvelle entree au clavier
					{
						strcpy(chaine, "00\0");
						raz_chaine=0; //ne plus la remettre a 0 dans ce waitclick
					}
					if (touche_valide(ev.xkey.keycode)&&(c==1))
					{
						eteindre_tous_segments(mat);
						symbole = XKeycodeToKeysym(display, ev.xkey.keycode, 1); // A, B, C, KD_1, KD_5...
						caract = XKeysymToString(symbole)[0];                    // A, B, C, K, K...
						if (caract=='K') // cas d'un chiffre traduit "K"
							caract = XKeysymToString(symbole)[3];
						chaine[0]=chaine[1];
						chaine[1]=caract;
						chaine[2]='\0';
						XUnmapWindow(display, CLAVIER_.win);
						CLAVIER_.val = /*conv(chaine);*/(unsigned char)strtol(chaine,(char **)NULL,16); // lecture d'une chaine hexa
						strcpy(chaine,"\0");
						Dessiner(&CLAVIER_);
						saisie_effectuee=1;
						strcpy(inf->saisie, "");
						ecrire_infos(inf,3);
					}
				}
				break;

			case EnterNotify :
				if(((ev.xbutton.window == cycle_.win)&&(RAM_.status==1)) ||((ev.xbutton.window == ldram_.win)&&(RAM_.status==0)) || (ev.xbutton.window == quit_.win))
					XDefineCursor(display, win, curs_main);
				break;

			case LeaveNotify :
				if( (ev.xbutton.window == cycle_.win) ||(ev.xbutton.window == ldram_.win) || (ev.xbutton.window == quit_.win) )
					XDefineCursor(display, win, curs_fleche);
				break;


			default : break;
		}
	}
	return b; //retourne 0 si on clicker sur quit
		  //retourne 1 si on clicker sur cycle ou sur une touche cycle du clavier
}


//----------------------------------------------------------------------------------
// prcde chaque mnmonique
//----------------------------------------------------------------------------------
int fetch(int **mat, BOITE *tab, INFOS *inf)
{
	strcpy(inf->latence,"");
	ecrire_infos(inf,1);
	strcpy(inf->lat_periph,"");
	ecrire_infos(inf,4);
	strcpy(inf->instruction, "FETCH");
	ecrire_infos(inf,2);
// bus PC-RA   -   RA<-PC
	PC_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Incremente PC & RAM->RM
	if(incdec(mat, tab, inf, 1,'+')==0)
		return 0;

// bus RM-RI   -   RI<-RM
	//affichage des bus
	eteindre_tous_segments(mat);
	colorer_segment(mat,0,9, 1,2,5,6,7,8,21,22,25); // on affiche les 9 segments 1 2 5 6 7 8 21 22 25

	XUnmapWindow(display, RI_.win);
	RI_.val=RM_.val;
	Dessiner(&RI_);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// bus RI-decode   -   Decodeur<-RI
	//affichage des bus
	eteindre_tous_segments(mat);
	colorer_segment(mat,1,2, 62,66); // on affiche les 9 segments 1 2 5 6 7 8 21 22 25
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Decode
	eteindre_tous_segments(mat);
	strcpy(inf->instruction, "DECODE");
	ecrire_infos(inf,2);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

	return 1;
}


//----------------------------------------------------------------------------------
// inc/decrmentation du PC ou SP, par une unit approprie
// attention, fait egalement une ecriture en RAM dans le cas d'une incr. du SP !
//----------------------------------------------------------------------------------
int incdec(int **mat, BOITE *tab, INFOS *inf, int reg,char op)
{
	if(reg==1)
	{
		strcpy(incdec_.titre,"Incremente");
		// bus PC-incrPC
   			if(strcmp(inf->latence, " ")==0) // espace mis par RA_RAM pour demander l'affichage de "Latence"
			{
				strcpy(inf->latence, "Latence");
				ecrire_infos(inf,1);
			}
			eteindre_tous_segments(mat);
			colorer_segment(mat,0,5, 23,22,26,27,67);
			XUnmapWindow(display, incdec_.win);
			incdec_.val=PC_.val;
			Dessiner(&incdec_);
			if(waitclick(mat, tab, inf, 0)==0)
				return 0;

		// incrPC ++
			eteindre_tous_segments(mat);
			strcpy(inf->latence, "");
			ecrire_infos(inf,1);
			RAM_RM(tab,mat,inf);
			XUnmapWindow(display, incdec_.win);
			incdec_.val++;
			Dessiner(&incdec_);
			if(waitclick(mat, tab, inf, 0)==0)
				return 0;

		// bus incrPC-PC
			eteindre_tous_segments(mat);
			colorer_segment(mat,0,5, 23,22,26,27,67);
			XUnmapWindow(display, PC_.win);
			PC_.val=incdec_.val;
			Dessiner(&PC_);
			if(waitclick(mat, tab, inf, 0)==0)
				return 0;
			eteindre_tous_segments(mat);
	}
	else
	// SP++ va toujours de pair avec l'ecriture RAM
	{
		// bus SP-incdec
			eteindre_tous_segments(mat);
			colorer_segment(mat,0,3, 24,26,67);
			XUnmapWindow(display, incdec_.win);
			incdec_.val=SP_.val;
			Dessiner(&incdec_);

			if(op=='-')
			{
				colorer_segment(mat,0,6, 0,52,53,54,55,56); //ecr_RAM_1
				strcpy(inf->latence, "Ecriture 0%"); //ecr_RAM_1
				ecrire_infos(inf,1); //ecr_RAM_1
				surbrillance(tab,RA_.val); //ecr_RAM_1
			}

			if(waitclick(mat, tab, inf, 0)==0)
				return 0;

		// on fait l'operation
			eteindre_tous_segments(mat);
			XUnmapWindow(display, incdec_.win);
			if(op=='-')
			{
				strcpy(incdec_.titre,"Decremente");
				incdec_.val--;
				strcpy(inf->latence, "Ecriture 50%"); //ecr_RAM_2
				ecrire_infos(inf,1); //ecr_RAM_2
				colorer_segment(mat,0,1, 0); //ecr_RAM_2
			}
			else
			{
				strcpy(incdec_.titre,"Incremente");
				incdec_.val++;
			}
			Dessiner(&incdec_);
			if(waitclick(mat, tab, inf, 0)==0)
				return 0;

		// incdec ->SP
			eteindre_tous_segments(mat);
			if(op=='-')
			{
				strcpy(inf->latence, "Ecriture 100%"); //ecr_RAM_3
				ecrire_infos(inf,1); //ecr_RAM_3
				colorer_segment(mat,0,1, 0); //ecr_RAM_3
				XUnmapWindow(display,RAM_.win); //ecr_RAM_3
				RAM_.buffer[RA_.val]=RM_.val; //ecr_RAM_3
				Dessiner(&RAM_); //ecr_RAM_3
				surbrillance(tab,RA_.val); //ecr_RAM_3
			}
			colorer_segment(mat,0,3, 24,26,67);
			XUnmapWindow(display, SP_.win);
			SP_.val=incdec_.val;
			Dessiner(&SP_);
			affiche_tous_segments(mat);
			if(op=='+') // car pour SP++, on doit le faire dans le POP ou le CALL, sinon y'a un clic "dans  le vide"
			{
   				if(waitclick(mat, tab, inf, 0)==0)
					return 0;
			}
	}
	strcpy(incdec_.titre,"Incr/Decr");
	Dessiner(&incdec_);
	return 1;
}

int lect_incr(int **mat, BOITE *tab, INFOS *inf)
{


// bus PC-RA   -   RA<-PC
	PC_RA(tab,mat);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// RA~~RAM
	RA_RAM(tab,mat,inf);
	if(waitclick(mat, tab, inf, 0)==0)
		return 0;

// Incremente PC & RAM -> RM
	if(incdec(mat, tab, inf, 1,'+')==0)
		return 0;

	return 1;
}


void incr_cycle(BOITE* tab)
{
	static int phase=-1; // car il y a 4 phase 0 1 2 3
	phase++;
	XUnmapWindow(display,cycle_.win);
	if(phase==4)
	{
		phase=0;
		cycle_.val++;
		strcpy(cycle_.titre,"Cycle.   "); // 3 espaces pour effacer les 3 '.' et recommencer avec un seul
	}
	else
		cycle_.titre[phase+5]='.';
	Dessiner(&cycle_);

}


